%ext ck1

#Change tile yorp message head becomes
%patch $455E $B2 $01

#First Yorp message: [Level 2]
%patch 0x015080 "Mortimer says:      "
%patch 0x015096 "                    "
%patch 0x0150AC "So decided to thwart"
%patch 0x0150C2 "me huh? Well no     "
%patch 0x0150D8 "matter, this planet "
%patch 0x0150EE "will soon put a stop"
%patch 0x015104 "to you. Muhahaha!   "

#Second Yorp message [level 6] -7 lines
%patch 0x01511A "Snake Logan says:   "
%patch 0x015130 "                    "
%patch 0x015146 "Oh thankyou for     "
%patch 0x01515C "rescuing me! I guess"
%patch 0x015172 "this makes us even  "
%patch 0x015188 "Commander Keen. Oh, "
%patch 0x01519E "look out for Mort!  "

#Third Yorp message: [level 9] -7 lines
%patch 0x0151B4 "Mortimer snarls:    "
%patch 0x0151CA "                    "
%patch 0x0151E0 "So you survived the "
%patch 0x0151F6 "terrors of this     "
%patch 0x01520C "planet eh Keen?     "
%patch 0x015222 "Maybe I'll have to  "
%patch 0x015238 "see to you personaly"

#Fourth Yorp message: [Level 10] -7 lines
%patch 0x01524E "Mortimer expouses:  "
%patch 0x015264 "                    "
%patch 0x01527A "Got another part    "
%patch 0x015290 "have we? You know   "
%patch 0x0152A6 "that now I have no  "
%patch 0x0152BC "choice but to kill  "
%patch 0x0152D2 "you, don't you?     "

#Fifth Yorp Message: [level 12] -7 lines
%patch 0x015340 "Mortimer smirks:    "
%patch 0x015356 "                    "
%patch 0x01536C "Well well, you look "
%patch 0x015382 "a little washed up eh"
%patch 0x015399 "314? Your new weapon"
%patch 0x0153AF "will be no match for"
%patch 0x0153C5 "my techbots!        "

#Sixth Yorp message: [level 15] -6 lines
%patch 0x0153DB "Mortimer gloats:    "
%patch 0x0153F1 "                    "
%patch 0x015407 "Ah, all four parts. "
%patch 0x01541D "And all in one place"
%patch 0x015433 "too! Thankyou for   "
%patch 0x015449 "your help, 314.     "

#Garg message: [level 11] -4 lines
%patch 0x0152E8 "Mortimer jokes:     "
%patch 0x0152FE "                    "
%patch 0x015314 "Cold enough for you,"
%patch 0x01532A "Captain Chill?      "

# Keen does not lose ship parts on dying in their levels. 
%patch 0x4F82 $90 $90 $90 $90 $90 $90 #Joystick
%patch 0x4F8A $90 $90 $90 $90 $90 $90 #Battery
%patch 0x4F92 $90 $90 $90 $90 $90 $90 #Vacum
%patch 0x4F9A $90 $90 $90 $90 $90 $90 #everclear

#Don't show Press F1 for help sprite
%patch $97C9 $90

# The title bitmap will be shown at offset 0,0 
%patch $97B2   $00 $00     # Y location, in pixels 
%patch $97B6   $04 $00     # (X location in pixels) / 8 + 4 

#Start patches
#No id software bitmap
%patch $A248 $90 $90 $90
#of an h pos
%patch  $A233 $00 $00
#sprite for 'of an'
%patch  $A22B $0B
#No production bitmap
%patch $A25A $90 $90 $90
#Presentation h cordinates
%patch  $A221 $0F $00
#Presentation v co ordinates.
%patch  $A21D $30

# This is the color palette: 16 entries of r, g, b (each 0-63) 
%patch $13054 
       00 00 00 # black 
       00 00 42 # blue 
       00 42 00 # green 
       21 42 63 # cyan 
       42 00 00 # red 
       42 00 42 # magenta 
       42 21 00 # brown 
       42 42 42 # bright gray 
       21 21 21 # gray 
       21 21 63 # bright blue 
       32 53 10 # bright green 
       21 63 63 # bright cyan 
       63 39 00 # bright red 
       63 21 63 # pink 
       63 63 21 # yellow 
       63 63 63 # white 
# Set the palette when we go into graphics mode 
%patch $6E46  $E8 $D3 $D5 $90 $90 
# Code to set graphics mode and set the palette 
%patch $441C                  $B8 $0D $00 $CD 
              $10 $B8 $12 $10 $B9 $08 $00 $BB 
              $00 $00 $8C $DA $8E $C2 $BA $04 
              $00 $CD $10 $BB $18 $00 $BA $1C 
              $00 $CD $10 $C3 
# Include this part if the "Change background tiles" patch is not used 
# It gives us 36 spare bytes for the palette-setting code 
%patch $4409      $B8 $14 $01 $26 $81 $3F $31 
              $01 $73 $03 $B8 $8F $00 $26 $89 
              $07 $E9 $5C $01 


# yorp movement- left speeds = $FF $FF MINUS desired speed
%patch $18D4 $E2 $FF # [si+20] left speed
%patch $18CD $1E $00 # [si+20] right speed
%patch $19C2 $E2 $FF # [si+20] left speed
%patch $19CE $1E $00 # [si+20] right speed
%patch $1964 $00 $01 # [si+22] yorps jump higher when this is higher
%patch $1A1C $E2 $FF # [si+20] left speed
%patch $1A14 $1E $00 # [si+20] right speed

# dead vort turns into yorp [and thus the flitter gun is created]
%patch $1D8D $90 $90 $90 $90 $90 $90 $90 $90 $90
%patch $1DAF $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
%patch $1DAD $4F $19
%patch $1DA8 $68 $1A
%patch $1DA3 $30 $00
%patch $1D98 $00 $02 $00
# Level on which vorticon commander appears     
%patch $1813  $0F
# Strength of regular vorticon (1 less than # shots) 
%patch $180D  $02 $00 
# Strength of vorticon commander (1 less than # shots)       
%patch $1819  $10 $00 

# Robot turns to dead Vort when shot 
%patch $176D $6E $1D 
# Robot kills Keen on touch 
%patch $171E $03 $00
#robot's shots kill Keen but not other enemies
%patch $48E9 $04 $00 

#Garg becomes a dead vort when shot
%patch $1876 $6E $1D

#Destructable iceblocks [2 coliding destroy each other]
%patch $213E $00 $4A 
# Make big ice blocks kill Keen. 
%patch $20D6 $03 $00
#Ice cannon shoot rate
%patch $2058 $08

#Change the tiles the block leaves behind
%patch $23AB $8F $00 #left
%patch $2414 $8F $00 #middle
%patch $2494 $8F $00 #right
%patch $23EF $E1 $00 #top l corner
%patch $2458 $E2 $00 #top middle
%patch $24D8 $E3 $00 #top r corner
#Number of tiles block falls
%patch $24E8 $05
#Bottom right tile vertical position
%patch $24C0 $01
#Bottom middle tile vertical position
%patch $2440 $01
#Bottom left tile vertical position
%patch $23D7 $01

#Status screen patch
%patch $11B4                   $55 $89 $E5 $B8 $0A $00 $50 $B8 $90 $82 $50 $FF 
               $76 $06 $FF $76 $04 $E8 $03 $C2 $83 $C4 $08 $B8 $90 $82 $50 $E8 
               $A5 $C5 $44 $44 $8B $56 $08 $29 $C2 $89 $16 $82 $82 $8B $46 $0A 
               $A3 $F8 $82 $B8 $90 $82 $50 $E8 $E8 $50 $44 $44 $89 $EC $5D $C3 

%patch $13084  "COMM.CK1" $00 
 
%patch $0E6A                                           $B8 $00 $3D $BA $34 $00    
               $CD $21 $89 $C3 $BF $27 $00 $C6 $06 $9A $82 $00 $B9 $0A $00 $BA 
               $90 $82 $B4 $3F $CD $21 $53 $B8 $90 $82 $50 $E8 $2E $97 $44 $44 
               $5B $4F $75 $E8 $B4 $3E $CD $21 
                                               $8B $46 $FE $05 $01 $00 $50 $89   
               $F0 $05 $0A $00 $50 $FF $36 $CC $AA $FF $36 $CA $AA $E8 $04 $03 
               $83 $C4 $08 
                           $8B $46 $FE $05 $01 $00 $50 $89 $F0 $05 $1A $00 $50    
               $A1 $C4 $6E $8B $16 $C2 $6E $81 $C2 $20 $4E $15 $00 $00 $50 $52 
               $E8 $E1 $02 $83 $C4 $08 
                                       $31 $FF $3B $3E $C6 $AA $7D $29 $83 $FF   
               $06 $7D $24 $B8 $00 $00 $50 $8B $46 $FE $05 $03 $00 $B1 $03 $D3 
               $E0 $90 $90 $50 $89 $F8 $D1 $E0 $05 $01 $00 $01 $F0 $50 $E8 $2C 
               $AC $83 $C4 $06 $47 $EB $D1 
%patch $0F07                               $B8 $41 $01 $83 $3E $94 $AA $00 $74    
               $03 $B8 $C0 $01 $50 $8B $46 $FE $05 $03 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $10 $00 $50 $E8 $0D $AA $83 $C4 $06 
                                                                           $B8   
               $42 $01 $83 $3E $9C $AA $00 $74 $03 $B8 $C1 $01 $50 $8B $46 $FE 
               $05 $03 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $13 $00 
               $50 $E8 $E5 $A9 $83 $C4 $06 
                                           $B8 $43 $01 $83 $3E $96 $AA $00 $74   
               $03 $B8 $C2 $01 $50 $8B $46 $FE $05 $03 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $16 $00 $50 $E8 $BD $A9 $83 $C4 $06 
                                                                           $B8   
               $44 $01 $83 $3E $98 $AA $00 $74 $03 $B8 $C3 $01 $50 $8B $46 $FE 
               $05 $03 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $19 $00 
               $50 $E8 $95 $A9 $83 $C4 $06 
%patch $0FA7                               $B8 $8F $00 $83 $3E $9E $AA $00 $74   
               $03 $B8 $A8 $01 $50 $8B $46 $FE $05 $07 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $13 $00 $50 $E8 $6D $A9 $83 $C4 $06 
                                                                           $B8   
               $8F $00 $83 $3E $A0 $AA $00 $74 $03 $B8 $A9 $01 $50 $8B $46 $FE 
               $05 $07 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $17 $00 
               $50 $E8 $45 $A9 $83 $C4 $06 
                                           $B8 $8F $00 $83 $3E $A2 $AA $00 $74   
               $03 $B8 $AA $01 $50 $8B $46 $FE $05 $09 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $13 $00 $50 $E8 $1D $A9 $83 $C4 $06 
                                                                           $B8   
               $8F $00 $83 $3E $A4 $AA $00 $74 $03 $B8 $AB $01 $50 $8B $46 $FE 
               $05 $09 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $17 $00 
               $50 $E8 $F5 $A8 $83 $C4 $06 
%patch $1047                               $B8 $8F $00 $83 $3E $9A $AA $00 $74   
               $03 $B8 $9F $01 $50 $8B $46 $FE $05 $08 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $0B $00 $50 $E8 $CD $A8 $83 $C4 $06 
                                                                           $8B   
               $46 $FE $05 $0B $00 $50 $89 $F0 $05 $06 $00 $50 $31 $C0 $50 $FF 
               $36 $C8 $AA $E8 $2E $01 $83 $C4 $08 
                                                   $B8 $9E $01 $50 $8B $46 $FE   
               $05 $07 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $03 $00    
               $50 $E8 $95 $A8 $83 $C4 $06                                       

                                           $E8 $90 $4B $31 $C0 $50 $E8 $1E $AD   
               $44 $44 $E8 $81 $A6 $E8 $D1 $F1 $E8 $CE $F1 $E8 $7C $4B $8B $46 
               $FC $8B $56 $FA $89 $16 $35 $51 $A3 $37 $51 $5F $5E $89 $EC $5D 
               $C3 

%patch $0FD0 $91 $01 #Tile for no  Keycard B
%patch $0FF8 $91 $01 #Tile for no  Keycard C
%patch $1020 $91 $01 #Tile for no  Keycard D
%patch $1048 $91 $01 #Tile for no  Pogo
%patch $0FA8 $91 $01 #Tile for no  Keycard A

#Disable noclipping on godmode map.
%patch $A626  $EB 

#Exit tiles don't change.
%patch $412E $00

#Pogo doesn't fly with Godmode
%patch $3F4E  $EB

#Number of scores in the high score table
%patch $9A18 $04

%patch $9002 $0A

%patch $992A  $DD $00   
%patch $995D  $ED $00   
%patch $9990  $F1 $00    
%patch $99C3  $F5 $00   

%patch $44A4  10

%patch $7D3A  $90 $90 $80 $BF $A6 $AA $00 
%patch $7FCA  $90 $90 $80 $BF $A5 $AA $00 

%patch $9065  $90 $90 $C6 $87 $A6 $AA $00 $90 
%patch $9070  $83 $7E $F8 $20 

%patch $8013  $90 $90 $C6 $87 $A5 $AA $01 $90 
%patch $7E48  $83 $7E $FC $20

%patch $46DC 08

%patchfile 0x130F8 bat.ck1

#Keen must find screen
%patch 0x0001659B "Keen must find these"
%patch 0x000165B0 "   parts.   "

#Change the border colors the color values are as follows:
# All these should have the same value -- this is the usual border color 
%patch $4A62   $02 #Color after killing a vorticon
%patch $6F9D   $04 #Color after killing vorticon commander
%patch $15568  $00 #Darkest fade color
%patch $15579  $38 #Medium fade color
%patch $1558A  $05 #light fade color
%patch $1559B  $3D #Normal border color

# The two colors that the border flashes when a Vorticon dies 
%patch $4A7D $3F 
%patch $4A85 $01 

#God Cheat Code- LEV
%patch 0x0120D 0x5052
%patch 0x01214 0x503E
%patch 0x0121B 0x505B
#Text
%patch 0x01500A "INVINCIBILITY!!!"
%patch 0x01501B "Possible death!!!"

#CTSpace Cheat Code - RLZ
%patch 0x011F5 0x503F
%patch 0x011FC 0x5052
%patch 0x01203 0x5058
#Text
%patch 0x014DEE "Resorting to cheating"
%patch 0x014E05 "how absolutely pathetic!  "
%patch 0x014E21 "REAL players don't use"
%patch 0x014E39 "cheats you slime mould! "

%patch 0x015F80 "Hi I am Adriael, a long-time Keen "
%patch 0x015FA8 "fan and a new mod-maker. Big     "
%patch 0x015FD0 "thanks to all those whose     "
%patch 0x015FF8 "graphics and stuff  "
%patch 0x016020 "contributed to this mod. To     "
%patch 0x016048 "everyone else, enjoy the game and  "
%patch 0x016070 "watch out for the next    "
%patch 0x016098 "episodes comming soon! "
%patch 0x0160C0 "Hey Apogee! release Keen 7   "
%patch 0x0160E8 "now before I come over there and "
%patch 0x016110 "recolour your palette!   "

#Menu text
%patch 0x015EF6 "Restore  Game"
%patch 0x015F12 "About Me..."
%patch 0x015F22 "The Keenest"
%patch 0x015F32 "             "
#Make  Ordering info  have no effect.
%patch $95A3  $EB $AD

#####
#End
#####

#First we fiddle the basic stuff;
#Teh text appearance speed!
%patch $8173 $04 $00
#Pause between exiting and ending sequence [teh black screen]
%patch $820D $3C $00

#Now we relocate and fiddle  all the window sprites:
#1st, light Window x location
%patch $8596 $13 $00
#Sprite used for window
%patch $858F $0C $00
#Light turning on sound [max value $40]
%patch $85A0 $19 $00
#[How long the window stays lit]
%patch $85A9 $10 $00

#2nd, Dark Window x location
%patch $85B9 $15 $00
#Dark window sprite
%patch $85B2 $0C $00
#Light turning off sound [max value $40]
%patch $85C3 $19 $00
#Pause between window going dark and second textbox appearing
%patch $85CC $10 $00

#Puase between texbox dissapearing and window lighting up
%patch $8612 $3C $00
#Sprite used for 3rd window
%patch $861B $0B $00
#Window x location
%patch $8622 $17 $00
#Light turning on sound [max value $40]
%patch $862C $19 $00

#Sprite used for 4th window
%patch $8748 $0D $00
#Window x location
%patch $874F $19 $00
#Light turning off sound [max value $40]
%patch $8759 $19 $00
#Puase between window going dark and lighting up
%patch $8762 $2C $00

#Sprite used for 5th, dark window
%patch $876B $0D $00
#Window x location
%patch $8772 $1B $00
#Light turning on sound [max value $40] [Here occurs AFTER textbox setup.]
%patch $8792 $19 $00

#Then we remove some of the textboxes:
#Stop 3rd textbox appearing
%patch $8635 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90
#Stop 4th textbox appearing
%patch $867B $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90
#Stop 5th textbox appearing
%patch $86AF $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
#Stop 6th textbox appearing
%patch $86EC $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90
#Stop 7th textbox appearing
%patch $8714 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90


#Now we make all the remaining textboxes the same size [and shorten text]:
#First Keens house textbox bottom
%patch $8546 $15 $00
#First Keens house textbox right side
%patch $854A $23 $00
#First Keens house textbox top
%patch $854E $0F $00
#First Keens house textbox left side
%patch $8552 $0C $00
#Length textbox appears [AFTER text stops writing!]
%patch $857A $10 $00

#Second textbox bottom
%patch $85D5 $15 $00
#Second Keens house textbox right side
%patch $85D9 $23 $00
#Second Keens house textbox left side
%patch $85E1 $0C $00
#Length textbox appears [AFTER text stops writing!]
%patch $8606 $10 $00

#Eighth textbox bottom
%patch $877C $15 $00
#Eighth Keens house textbox right side
%patch $8780 $23 $00
#Eighth Keens house textbox left side
%patch $8788 $0C $00
#Second Line of text read from:
%patch $87A4 $CF $2D


#And finally fill in the remaining text:
%patch 0x015C24 "As Keen makes his way back to his  "
%patch 0x015C49 "ship, he is ambushed and captured"
%patch 0x015C6C "by a dozen techbots! What will be  "
%patch 0x015C91 "his fate at the hands of Mort? "

%patch 0x015CBD "Your nefarious scheme "
%patch 0x015CD5 "will never succeed"
%patch 0x015CE9 "Mortimer!!       "

%patch 0x015CFB "And I suppose YOU  "
%patch 0x015D10 "will stop me? With "
%patch 0x015D25 "what??    "


%patch 0x015E07 "No ship, no wepons,  "
%patch 0x015E1E " and no sense! In just "
%patch 0x015E37 "a few hours my plan"
%patch 0x015E4C "to 'enlighten' Earth "
%patch 0x015E63 "will succeed! "

%end